#!/usr/bin/env python
#-*- coding:utf-8 -*-

import requests
from struct import pack

def xor(a, b):
    return "".join([chr(ord(a[i]) ^ ord(b[i%len(b)])) for i in xrange(len(a))])

url = "http://cryptochallenge.nds.rub.de:50080/service"

data = """eyJhbGciOiJSU0FfT0FFUCIsIml2IjoieXY2NnZ2ck8yNjNleXZpSSIsInR5cCI6IkpXVCIsImVuYyI6IkExMjhHQ00ifQ==.
ZBnPlwONWHxGDrtCxxopS4y4SrMZIAhUg3HI+SbLMxfPVRPW8yunejrkmfSLO1H/0tOx4ssggygHjG7sUfxL8A==.
i2vygn2vqFpsmep3etrD5Yh5xLP9xYhJdvn63WmHEPYChA==."""

def split(data):
    s = [x.rstrip(".").decode("base-64") for x in data.split()]
    return s

def join(stuff, rsa, aes):
    s = ""
    for x in stuff, rsa, aes:
        s += x.encode("base-64") + ".\n"
    return s[:-1]

algo_choice, rsa, aes = split(data)
block1 = aes[:16]
counter = 2
msg_pattern = '{"My PIN:":"%04d' # 16 bytes

for pin in xrange(10000):
    msg = msg_pattern % pin

    for pad in (0x1, 0x202, 0x30303):
        iv = "yv66vvrO263eyviI".decode("base64").rstrip()
        iv += pack(">I", counter ^ pad)

        algo_choice = '{"alg":"RSA-OAEP","iv":"%s","typ":"JWT","enc":"A128CBC"}' % iv.encode("base64").rstrip(" \n=")
        aes = xor(block1, msg)

        r = requests.post(url, data=join(algo_choice, rsa, aes))
        if "pad block corrupted" in r.content:
            break

        print "PIN %04d PASSED %08x PAD" % (pin, pad)